﻿#ifndef __GEOMETRYDATA_H__
#define __GEOMETRYDATA_H__

#include "RenderDefines.h"
#include "BoundingBox.h"
#include <climits>

struct VertexData
{
	// total primitive in an object
	VertexPrimitiveType numPrimitives;
	// total vertices in an object
	VertexPrimitiveType numVertices;
	// vertex buffer
	uint vb;

	void ResetDrawingData()
	{
		numPrimitives = 0;
		numVertices = 0;
	}

	void Reset()
	{
		ResetDrawingData();
		//vb.Reset();
	}
	//bool IsValid() const
	//{
	//	return vb.IsValid() && numVertices && numPrimitives;
	//}
	VertexData() : numPrimitives(0), numVertices(0)
	{
	
	}
};

// geometry data for 3D objects
struct GeometryData : VertexData
{
	// index buffer
	IndexBuffer ib;
	// a bounding box of object
	BoundingBox box;

	//bool IsValid() const
	//{
	//	return VertexData::IsValid() && ib.IsValid() && box.IsValid();
	//}

	void Reset()
	{
		VertexData::Reset();
		box.Reset();
		ib.Reset();
	}
};

#endif //__GEOMETRYDATA_H__
