﻿#ifndef __RENDERDEFINES_H__
#define __RENDERDEFINES_H__

#include "types.h"
#include <climits>

class Render;
class Camera;

struct Handle
{
	uint handle;

	Handle() : handle(UINT_MAX)
	{
	}
	template<typename T>
	Handle(T val) : handle(static_cast<uint>(val))
	{
	}
	template<typename T>
	Handle& operator = (T val)
	{
		handle = static_cast<uint>(val);
		return *this;
	}
	bool IsValid() const
	{
		return handle != UINT_MAX;
	}
	void Reset()
	{
		handle = UINT_MAX;
	}
	operator const uint & () const
	{
		return handle;
	}
};

template<typename ResourceType>
struct GraphicsResource : public Handle
{
	GraphicsResource<ResourceType>(uint val) : Handle(val)
	{
	}
	GraphicsResource<ResourceType>() : Handle()
	{
	}
};

struct IB 
{ 
};

struct VB
{
};

struct Tex
{
};

struct FontDef
{
};

struct RenderToTextureDef
{

};

typedef GraphicsResource<IB> IndexBuffer;
typedef GraphicsResource<VB> VertexBuffer;
typedef GraphicsResource<Tex> Texture;
typedef GraphicsResource<FontDef> TpsFont;
typedef GraphicsResource<RenderToTextureDef> RenderToTexture;

#ifndef UNDER_CE
enum
{
	MAX_VERTICES = UINT_MAX
};
typedef uint VertexPrimitiveType;
#else
typedef ushort VertexPrimitiveType;
enum
{
	MAX_VERTICES = USHRT_MAX
};
#endif

#define ASCII

#endif
