﻿#ifndef __TYPES_H__
#define __TYPES_H__

typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned char uchar;
typedef uint u32;
typedef ushort uint16;
typedef ushort u16;
typedef uchar u8;
typedef uchar ubyte;
typedef uchar uint8;
typedef wchar_t wchar;
//typedef ulong ULONG; // avoid using long types
//typedef ULONG DWORD; // DWORD is 32-bits
typedef uint UINT;
typedef ushort USHORT;
typedef ushort WORD;
typedef uchar UCHAR;
typedef wchar WCHAR;

#if defined(__GNUC__) || defined(__llvm__)

typedef signed char	int8;
typedef signed short   int16;
typedef signed long	int32;

typedef unsigned long  uint32;
typedef unsigned long long uint64;

#ifndef UNUSED
#define UNUSED(x) x;
#endif

#ifdef NO_TPS_HEADERS
#define UNALIGNED
#define insertUniqueElement(x, y)

typedef void* HWND;
typedef uint COLORREF;
typedef void* HBITMAP;
typedef uchar BYTE;

enum
{
	TRUE = 1,
	FALSE = 0,
	MAX_PATH = 256,
	WM_APP = 0,
	INVALID_HANDLE_VALUE = 0xffffffff
};

struct POINT
{
	int x;
	int y;
};

struct tagRECT
{
	long left;
	long top;
	long right;
	long bottom;
};

typedef tagRECT RECT;
#endif

#else
typedef __int64 int64;
typedef unsigned __int64 uint64;
#pragma warning(disable : 4482)
#endif

#if defined(__ANDROID__) || defined(__linux__) || (defined(__APPLE__) && defined(__MACH__)) || defined(__MINGW32__)
#define STRDEF(str) str
typedef char CharType;
#else
typedef wchar CharType;
#define STRDEF(str) L##str
#endif

#ifdef _M_AMD64
typedef uint64 ObjId;
#else
typedef int ObjId;
#endif

#endif // __TYPES_H__
